
{///////////////////////////////////////////////////////////////////////////}
{/                                                                         /}
{/  RAM - BACKUP : Kopiert Dateien zwischen Laufwerken und Unterverzeich-  /}
{/                 nissen als Backup ( d.h. alte Version wird umbenannt    /}
{/                 in .BAK, neue Version wird unter dem Namen gesichert).  /}
{/                                                                         /}
{/  Dieses PUBLIC DOMAIN Programm wurde 1986 mit ST Pascal plus von CCD    /}
{/                                                                         /}
{/  entwickelt von                                   ERHARD SCHWARTZ       /}
{/                                                   Isaraustrae 8        /}
{/  Version 1.50 vom 10.09.87                    D - 8192 Geretsried 1     /}
{/                                                                         /}
{/                                                                         /}
{/  NEU : Um auch  Anfngern und Umsteigern den  Einstieg in diese schne  /}
{/        Programmiersprache  zu  erleichtern, sind  ab sofort  auch  die  /}
{/        Pascal-Sources meiner Programme PUBLIC DOMAIN.                   /}
{/        Sollte  jedoch jemand dieses Programm selbst oder zumindest die  /}
{/        Source als Anregung fr eigene Programme gut gebrauchen knnen,  /}
{/        so bitte ich um  berweisung eines kleinen Unkostenbeitrags auf  /}
{/        folgendes Konto:                                                 /}
{/        Kreissparkasse Wolfratshausen, BLZ 70054306, Konto-Nr. 670588    /}
{/                                                                         /}
{///////////////////////////////////////////////////////////////////////////}

{$A+} { Programm soll ein Accessory werden   }
{$S5} { Heap und Stack mit 5k                }
{$D-} { Ohne Debug                           }
{$P-} { Keine berprfung von Zeigern        }
{$R-} { Keine Unterbereichsprfung           }
{$T-} { Keine berprfung von Heap und Stack }


PROGRAM ACCESSORY_BACKUP_by_ERHARD_SCHWARTZ;

CONST   {$I GEMCONST.INC}
        VERSION                 = '1.50';
        MAX_C_STRING_LEN        = 81;
        BOX_LEN                 = 52;
        MUSTER                  = 17;
        MAXBYTE                 = 1024;

TYPE    {$I GEMTYPE.INC}
        c_string        = PACKED ARRAY[1..MAX_C_STRING_LEN] OF CHAR;
        ext_typ         = STRING[3];

        rwbuftyp        = PACKED ARRAY[1..MAXBYTE] OF CHAR;

        dtabuftyp = RECORD              { Struktur des DTA-Puffers }
                      dos    : PACKED ARRAY[0..21] OF CHAR;
                      time,
                      date   : INTEGER;
                      size   : LONG_INTEGER;
                      name   : PACKED ARRAY[1..14] OF CHAR;
                    END;

        p_buf   = RECORD
                    freie_cluster,
                    gesamt_cluster,
                    bytes_pro_sector,
                    sectoren_pro_cluster : LONG_INTEGER;
                  END; { record }

VAR     ap_id,
        menu_id,
        mist,
        wahl            : INTEGER;

        dl              : dialog_ptr;

        angemeldet      : SET OF CHAR;

        q_drive,                        { Laufwerk fr Quelle und Ziel }
        z_drive         : CHAR;

        q_dr_str,                       { Diverse Strings }
        z_dr_str,
        t,
        frag_leer,
        acc_name        : str255;

        quell_btn,                      { Namen aus dem Dialog }
        ziel_btn,
        ordner_btn,
        quell_name,
        ziel_name,
        quell_drive,
        ziel_drive,
        start_btn,
        cancel_btn      : INTEGER;

        erfolg,                                 { Flags }
        kopier_stop     : BOOLEAN;

        in_fil_path,
        out_fil_path    : path_name;
        extension       : ext_typ;

        fenster,                        { Daten des Hintergrundfensters }
        fenst_x,
        fenst_y,
        fenst_w,
        fenst_h         : INTEGER;
        fenstername     : window_title;


{///////////////////////////////////////////////////////////////////////////}
{///  Definition der bentigten GEMDOS- und Bibliotheks-Routinen   /////////}
{///////////////////////////////////////////////////////////////////////////}

        {$I GEMSUBS.INC}

FUNCTION  drvmap        : INTEGER;                              BIOS ( 10);

FUNCTION  dgetdrv                               : INTEGER;      GEMDOS($19);
PROCEDURE fsetdta( VAR dtabuf : dtabuftyp);                     GEMDOS($1A);
FUNCTION  dfree  ( VAR p : p_buf; d : INTEGER)  : INTEGER;      GEMDOS($36);
FUNCTION  dcreate( VAR path : c_string )        : INTEGER;      GEMDOS($39);
FUNCTION  fcreate( VAR nam : c_string; att:INTEGER): INTEGER;   GEMDOS($3C);
FUNCTION  fopen  ( VAR nam : c_string; att:INTEGER): INTEGER;   GEMDOS($3D);
FUNCTION  fclose ( handle : INTEGER)            : INTEGER;      GEMDOS($3E);
FUNCTION  fread  ( handle : INTEGER; cnt : LONG_INTEGER;
                   VAR rwbuf : rwbuftyp) : LONG_INTEGER;        GEMDOS($3F);
FUNCTION  fwrite ( handle : INTEGER; cnt : LONG_INTEGER;
                   VAR rwbuf : rwbuftyp) : LONG_INTEGER;        GEMDOS($40);
FUNCTION  fdelete( VAR nam : c_string)          : INTEGER;      GEMDOS($41);
FUNCTION  fsfirst( VAR p : c_string; att:INTEGER)   : INTEGER;  GEMDOS($4E);
FUNCTION  frename( res:INTEGER; VAR q, z:c_string)  : INTEGER;  GEMDOS($56);


{///////////////////////////////////////////////////////////////////////////}
{///  Hier werden einige Voreinstellungen gemacht   ////////////////////////}
{///////////////////////////////////////////////////////////////////////////}

PROCEDURE initialisiere;
VAR     i       : INTEGER;
        logged_drive    : CHAR;
BEGIN
  logged_drive := chr( dgetdrv + 65);
  IF 'A' IN angemeldet
  THEN z_drive := 'A'
  ELSE z_drive := logged_drive;

  q_drive := 'Q';
  REPEAT q_drive := pred( q_drive)      { Hchstes Laufwerk als Quelle }
  UNTIL q_drive IN angemeldet;
  IF q_drive = 'B' THEN q_drive := logged_drive;

  erfolg         := FALSE;
  in_fil_path    := '';
  out_fil_path   := '';
  extension      := 'PAS';              { Voreinstellung : *.PAS }

  FOR i := 1 TO BOX_LEN DO frag_leer[i] := ' ';
  FOR i := 2 TO 4 DO frag_leer[i] := '?';
  frag_leer[0] := chr(BOX_LEN);
END; { procedure initialisiere }


{///////////////////////////////////////////////////////////////////////////}
{///   Ermittlung der angemeldeten Laufwerke   /////////////////////////////}
{///////////////////////////////////////////////////////////////////////////}

PROCEDURE erlaubte_laufwerke;
VAR     map     : INTEGER;
        ch      : CHAR;
BEGIN
  angemeldet := [];             { Zunchst kein angemeldetes Laufwerk }
  map := drvmap;
  FOR ch := 'A' TO 'P' DO
  BEGIN
    IF ( map & $01) = $01                       { Angemeldete Laufwerke }
    THEN angemeldet := angemeldet + [ch];       { im Bitvektor suchen }
    map := shr( map, 1);                        { Bits um eine Position }
  END; { for - Schleife }                       { nach rechts schieben }
END; { procedure erlaubte_laufwerke }


{///////////////////////////////////////////////////////////////////////////}
{///   U P C A S E   wandelt in Grobuchstaben um   ////////////////////////}
{///////////////////////////////////////////////////////////////////////////}

FUNCTION upcase ( ch : CHAR ) : CHAR;
BEGIN
  IF ( ch >= 'a') AND ( ch <= 'z' )
  THEN upcase := chr( ord( ch) - 32 )
  ELSE CASE ch OF
         ''  : upcase := '';
         ''  : upcase := '';
         ''  : upcase := '';
         ELSE : upcase := ch;
       END; { case }
END; { upcase }


{///////////////////////////////////////////////////////////////////////////}
{///   Umwandlung eines Pascal-Strings in einen C-String   /////////////////}
{///////////////////////////////////////////////////////////////////////////}

PROCEDURE pas_to_c_string ( pas_str : path_name; VAR c_str : c_string);
VAR     i       : INTEGER;
BEGIN
  FOR i := 1 TO length( pas_str) DO c_str[i] := pas_str[i];
  c_str[ length( pas_str) + 1] := #0; { Abschlu mit NUL }
END; { procedure pas_to_c_string }


{///////////////////////////////////////////////////////////////////////////}
{///   Ermittelt die Extension einer Datei   ///////////////////////////////}
{///////////////////////////////////////////////////////////////////////////}

PROCEDURE welche_extension( path : path_name; VAR extension : ext_typ );
VAR i, len, punkt  : INTEGER;
BEGIN
  len := length( path);
  i := len;
  punkt := 0;
  LOOP                                  { Von hinten her aufrollen }
    IF path[i] = '.' THEN punkt := i;   { bis zum Punkt }
  EXIT IF ( punkt > 0 ) OR ( path[i] = '\' ) OR ( i = 1 );
    i := i - 1;
  END; { loop }
  IF punkt > 0                          { Extension war da }
  THEN BEGIN
         FOR i := punkt + 1 TO len DO extension[i - punkt] := path[i];
         extension[0] := chr( len - punkt);
       END
  ELSE extension := '';
END; { procedure welche_extension }



{///////////////////////////////////////////////////////////////////////////}
{///   Hier wird geprft, ob eine Datei bereits existiert   ////////////////}
{///////////////////////////////////////////////////////////////////////////}

FUNCTION exist( filnam : path_name) : BOOLEAN;
VAR     path    : c_string;
BEGIN
  pas_to_c_string( filnam, path);
  exist := ( fsfirst( path, 0) = 0 );
END; { function exist }


{///////////////////////////////////////////////////////////////////////////}
{///   Hier wird die eigentliche Kopierarbeit erledigt   ///////////////////}
{///////////////////////////////////////////////////////////////////////////}

FUNCTION backup(q_name, z_name: path_name): BOOLEAN;

VAR     bak_name        : path_name;

        q_path,
        z_path,
        bak_path        : c_string;

        q_handle,
        z_handle,
        i               : INTEGER;

        dtabuf          : dtabuftyp;
        rwbuf           : rwbuftyp;

        r_byte,
        w_byte,
        rest,
        copybyte        : LONG_INTEGER;

        abbruch         : BOOLEAN;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
{~~~   Hier werden eventuelle Fehlermeldungen ausgegeben   ~~~~~~~~~~~~~~~~~}
{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}

  PROCEDURE backup_alarm( alarm : INTEGER );
  VAR t : str255;
  BEGIN
    CASE alarm OF
    1 : t := '[2][Kann angegebene Quelldatei|nicht finden][ABBRUCH]';
    2 : t := '[3][Kann angegebene Quelldatei|nicht ffnen][ABBRUCH]';
    3 : t := '[3][Kann angegebene Zieldatei|nicht ffnen][ABBRUCH]';
    4 : t := '[3][Fehler beim Einlesen|der Quelldatei][ABBRUCH]';
    5 : t := '[3][Fehler beim Schreiben|in Zieldatei][ABBRUCH]';
    6 : t := '[3][Zieldatei konnte nicht|geschlossen werden][OKAY]';
    7 : t := '[3][Quelldatei konnte nicht|geschlossen werden][OKAY]';
    8 : t := concat('[3][Alte .BAK-Datei konnte|nicht gelscht werden.|',
                    'Status vermutlich "nur lesen"][ABBRUCH]');
    9 : t := '[3][Diskette hat zu wenig Speicherplatz][ABBRUCH]';
    10: t := concat('[3][Alte Zieldatei konnte nicht|',
                    'in .BAK umbenannt werden.|',
                    'Status vermutlich "nur lesen"][ABBRUCH]');
    END; { case }
    mist := do_alert( t, 1);
    abbruch := TRUE;
  END; { procedure backup_alarm }

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
{~~~   Ermittelt den auf der Diskette vorhandene Speicherplatz    ~~~~~~~~~~}
{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}

  FUNCTION speicherplatz( drive : CHAR) : LONG_INTEGER;
  VAR   platz           : p_buf;
        drive_nr        : INTEGER;
  BEGIN
    drive_nr := ord( drive) - 64;               { A --> 1, B --> 2 etc. }
    IF dfree( platz, drive_nr) = 0
    THEN speicherplatz := platz.freie_cluster * platz.sectoren_pro_cluster
                          * platz.bytes_pro_sector
    ELSE speicherplatz := 0;
  END; { function speicherplatz }

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}

BEGIN { function backup }
  abbruch := FALSE;
  fsetdta( dtabuf);                     { Neue Adresse fr DTA-Puffer }
  bak_name := z_name;                   { Name der Backup-Datei erzeugen }
  i := length( bak_name);
  LOOP                                  { Extension lschen }
    IF bak_name[i] = '.' THEN bak_name[0] := chr(i-1);
  EXIT IF ( bak_name[i] = '\' ) OR ( bak_name[i] = '.' ) OR ( i = 1 );
    i := i - 1;
  END; { loop }
  bak_name := concat(bak_name,'.BAK');  { Datei hat Extension .BAK }
  pas_to_c_string(q_name,   q_path);    { C-Pathnamen aus Dateinamen machen }
  pas_to_c_string(z_name,   z_path);
  pas_to_c_string(bak_name, bak_path);

  IF NOT exist(q_name)  { Quell-Datei suchen und DTA-Puffer fllen }
  THEN backup_alarm(1)  { Block 1 : Quelldatei existiert nicht }
  ELSE
  BEGIN                                 { Block 2 : Quelldatei existiert }
    rest := dtabuf.size;        { Dateilaenge aus dem DTA-Puffer entnehmen }
    IF exist( bak_name) AND exist( z_name) { Alte .BAK mu gelscht werden }
    THEN IF NOT ( fdelete(bak_path) = 0 )
         THEN backup_alarm( 8);         { vermutlich Schreibschutz }
    IF NOT abbruch
    THEN
    BEGIN               { Block 15 : Bis jetzt kein Fehler aufgetreten }
      IF speicherplatz( z_drive) < rest
      THEN backup_alarm( 9)                     { Zu wenig Speicherplatz }
      ELSE
      BEGIN                     { Block 14 : Speicherplatz reicht aus }
        IF exist(z_name)        { Evtl. alte Datei in .BAK umbenennen }
        THEN BEGIN              { Block 3 : Zieldatei mu umbenannt werden }
               IF frename(0, z_path, bak_path) = 0 { Umbenennen in .BAK }
               THEN BEGIN END
               ELSE backup_alarm(10);   { vermutlich Schreibschutz }
             END;       { Block 3 : Alte Datei ist umbenannt in .BAK }
        IF NOT abbruch
        THEN
        BEGIN           { Block 16 : Bis jetzt kein Fehler aufgetreten }
          q_handle := fopen(q_path, 0);         { Quelldatei ffnen }
          IF q_handle < 0
          THEN backup_alarm(2)          { Block 4 : Quelle nicht geffnet }
          ELSE
          BEGIN                 { Block 5 : Quelle konnte geffnet werden }
            z_handle := fcreate(z_path, 0);     { Zieldatei erzeugen }
            IF z_handle < 0
            THEN backup_alarm(3)        { Block 6 : Ziel nicht geffnet }
            ELSE
            BEGIN               { Block 7 : Ziel konnte geffnet werden }
              abbruch := FALSE;
              WHILE (rest > 0) AND NOT abbruch DO
              BEGIN                             { Block 8 : Kopierschleife }
                IF rest > MAXBYTE
                THEN copybyte := MAXBYTE
                ELSE copybyte := rest;
                r_byte:= fread(q_handle,copybyte, rwbuf); { Puffer einlesen }
                IF r_byte <> copybyte                   { Fehler beim Lesen }
                THEN backup_alarm(4)    { Block 9 : Fehler beim Lesen }
                ELSE
                BEGIN                   { Block 10 : Kein Fehler beim Lesen }
                  w_byte:=fwrite(z_handle,copybyte,rwbuf);{ Puffer schreiben}
                  IF w_byte <> copybyte
                  THEN backup_alarm(5);         { Block 11 : Schreibfehler }
                END;                    { Block 10 : Kein Fehler beim Lesen }
                rest := rest - copybyte;
              END;                              { Block 8 : Kopierschleife }
            END;                { Block 7 : Ziel konnte geffnet werden }
            IF fclose( z_handle) <> 0
            THEN backup_alarm(6);       { Block 12 : Ziel nicht geschlossen }
          END;                  { Block 5 : Quelle konnte geffnet werden }
          IF fclose( q_handle) <> 0
          THEN backup_alarm(7); { Block 13 : Quelle nicht geschlossen }
        END;            { Block 16 : Bis jetzt kein Fehler aufgetreten }
      END;              { Block 14 : Speicherplatz reicht aus }
    END;                { Block 15 : Bis jetzt kein Fehler aufgetreten }
  END;                  { Block  2 : Quelldatei existiert }
  backup := NOT abbruch;
END; { function backup }


{///////////////////////////////////////////////////////////////////////////}
{///   Hier wird das Dialogfeld zusammengebaut   ///////////////////////////}
{///////////////////////////////////////////////////////////////////////////}

PROCEDURE baue_dialog;                  { Erstellt das Dialogfeld }
CONST   RA_ST_0         =  0;           { Rahmen-Strken }
        RA_ST_1I        = -1;
        RA_ST_2I        = 2;
        RA_ST_2A        =  2;
        NORM_FA         = $1181;    { Rahmen, Text, Muster sw, Text drber }
        MAX_D_ITEMS     = 18;

BEGIN

dl      := new_dialog( MAX_D_ITEMS, 0, 0, 70, 20);

mist    := add_ditem    ( dl, G_IBOX, NONE, 2, 1, 66, 5, RA_ST_2I, NORM_FA);
           obj_setstate ( dl, mist , OUTLINED , FALSE);

mist    := add_ditem    ( dl, G_TEXT, NONE, 2, 1, 66, 2, RA_ST_0, NORM_FA);
           obj_setstate ( dl, mist, NORMAL, FALSE);
           t := concat  ( 'RAM - BACKUP  V ', VERSION,
                          '  * PUBLIC DOMAIN * 1986/87 by E. SCHWARTZ');
           set_dtext    ( dl, mist, t, SYSTEM_FONT, TE_CENTER);

mist    := add_ditem    ( dl, G_TEXT, NONE, 2, 3, 66, 1, RA_ST_0, NORM_FA);
           obj_setstate ( dl, mist, NORMAL, FALSE);
           t := concat  ( 'ENTWICKELT MIT ST PASCAL PLUS VON CCD. KLEINE ',
                          'UNKOSTENBEITRGE FR DIESES PROGRAMM');
           set_dtext    ( dl, mist, t, SMALL_FONT, TE_CENTER);

mist    := add_ditem    ( dl, G_TEXT, NONE, 2, 4, 66, 1, RA_ST_0, NORM_FA);
           obj_setstate ( dl, mist, NORMAL, FALSE);
           t := concat  ( 'WERDEN JEDERZEIT GERNE ENTGEGENGENOMMEN VON :   ',
                          'ERHARD SCHWARTZ, ISARAUSTRASSE 8,');
           set_dtext    ( dl, mist, t, SMALL_FONT, TE_CENTER);

mist    := add_ditem    ( dl, G_TEXT, NONE, 2, 5, 66, 1, RA_ST_0, NORM_FA);
           obj_setstate ( dl, mist, NORMAL, FALSE);
           t := concat  ( 'D - 8192 GERETSRIED 1.  KONTO-NR. 670588, ',
                          'KREISSPARK. WOLFRATSHAUSEN, BLZ 70054306');
           set_dtext    ( dl, mist, t, SMALL_FONT, TE_CENTER);


quell_btn := add_ditem  ( dl, G_BUTTON, SELECTABLE|EXIT_BTN, 2, 8, 20, 2,
                          RA_ST_2I, NORM_FA);
             obj_setstate ( dl, quell_btn , OUTLINED, FALSE);
             set_dtext  ( dl, quell_btn, 'Quell-Datei ...', SYSTEM_FONT,
                          TE_CENTER);

ziel_btn   := add_ditem ( dl, G_BUTTON, SELECTABLE|EXIT_BTN, 25, 8, 20, 2,
                          RA_ST_2I, NORM_FA);
              obj_setstate ( dl, ziel_btn, OUTLINED|DISABLED, FALSE);
              set_dtext ( dl, ziel_btn, 'Ziel-Datei ...', SYSTEM_FONT,
                          TE_CENTER);

ordner_btn := add_ditem ( dl, G_BUTTON , SELECTABLE|EXIT_BTN, 48, 8, 20, 2,
                          RA_ST_2I, NORM_FA);
              obj_setstate ( dl, ordner_btn, OUTLINED, FALSE);
              set_dtext ( dl, ordner_btn, 'Neuer Ordner ...', SYSTEM_FONT,
                          TE_CENTER);

mist    := add_ditem    (dl, G_TEXT, NONE, 2, 12, 12, 1, RA_ST_0,  NORM_FA);
           obj_setstate ( dl, mist, NORMAL, FALSE);
           set_dtext    ( dl, mist, 'Kopiere von', SYSTEM_FONT, TE_RIGHT);

quell_name := add_ditem ( dl, G_BOXTEXT, NONE,16, 12, BOX_LEN,  1,
                          RA_ST_1I, NORM_FA);
                obj_setstate ( dl, quell_name, NORMAL, FALSE);
                set_dtext( dl, quell_name, frag_leer, SYSTEM_FONT, TE_LEFT);

mist    := add_ditem    ( dl, G_TEXT, NONE, 2,14,12, 1, RA_ST_0 , NORM_FA);
           obj_setstate ( dl, mist, NORMAL, FALSE);
           set_dtext    ( dl, mist, 'nach', SYSTEM_FONT, TE_RIGHT );

ziel_name := add_ditem  ( dl, G_BOXTEXT, NONE, 16, 14, BOX_LEN,  1,
                          RA_ST_1I, NORM_FA);
             obj_setstate ( dl, ziel_name, NORMAL, FALSE);
             set_dtext  ( dl, ziel_name, frag_leer, SYSTEM_FONT, TE_LEFT);

mist    := add_ditem    ( dl, G_TEXT, NONE, 2, 17, 12, 2, RA_ST_2A, NORM_FA);
           obj_setstate ( dl, mist, NORMAL, FALSE);
           set_dtext    ( dl, mist, 'Richtung :', SYSTEM_FONT, TE_CENTER);

quell_drive := add_ditem( dl, G_FBOXTEXT,EDITABLE, 15, 17, 4, 2, RA_ST_2A,
                          NORM_FA);
               obj_setstate ( dl, quell_drive, NORMAL, FALSE);
               set_dedit( dl, quell_drive, '_', 'a', q_drive, SYSTEM_FONT,
                          TE_CENTER);

mist    := add_ditem    (dl, G_TEXT, NONE, 20, 17, 5, 2, RA_ST_2A, NORM_FA);
           obj_setstate ( dl, mist, NORMAL, FALSE);
           set_dtext    ( dl, mist, '--->', SYSTEM_FONT, TE_CENTER);

ziel_drive  := add_ditem( dl, G_FBOXTEXT,EDITABLE, 26, 17, 4, 2,
                          RA_ST_2A, NORM_FA);
               obj_setstate ( dl, ziel_drive  , NORMAL, FALSE);
               set_dedit ( dl, ziel_drive ,  '_', 'a', z_drive,
                           SYSTEM_FONT, TE_CENTER);

start_btn  := add_ditem( dl,G_BUTTON,SELECTABLE|EXIT_BTN, 38, 17, 13, 2,
                         RA_ST_2A, NORM_FA);
              obj_setstate ( dl,start_btn,OUTLINED|DISABLED|SHADOWED, FALSE);
              set_dtext ( dl,start_btn, 'Los geht''s',SYSTEM_FONT,TE_CENTER);

cancel_btn := add_ditem( dl, G_BUTTON , SELECTABLE|EXIT_BTN, 55, 17, 13, 2,
                         RA_ST_2A, NORM_FA);
              obj_setstate ( dl, cancel_btn, OUTLINED, FALSE);
              set_dtext ( dl, cancel_btn, 'Abbruch', SYSTEM_FONT, TE_CENTER);

END; { procedure baue_dialog }


{///////////////////////////////////////////////////////////////////////////}
{///   Gibt Fehlermeldung aus, bei nicht angemeldetem Laufwerk   ///////////}
{///////////////////////////////////////////////////////////////////////////}

PROCEDURE nicht_angemeldet_alarm( ch : CHAR);
BEGIN
  t := concat( '[1][Laufwerk ', ch, '|nicht angemeldet !][OKAY]');
  mist := do_alert( t, 1);
  kopier_stop := TRUE;
END; { procedure nicht_angemeldet_alarm }


{///////////////////////////////////////////////////////////////////////////}
{///   Erstellt neuen Ordner   /////////////////////////////////////////////}
{///////////////////////////////////////////////////////////////////////////}

PROCEDURE neuer_ordner;
VAR     ord_path,
        vorschlag       : path_name;
        ord_c_path      : c_string;
        fehler          : INTEGER;
BEGIN
  ord_path := '';
  vorschlag := concat( z_drive, ':\*.ORD');
  IF get_in_file( vorschlag, ord_path)
  THEN
  BEGIN
    pas_to_c_string( ord_path, ord_c_path);
    fehler :=  - ( dcreate( ord_c_path) );
    CASE fehler OF
      0  : BEGIN END;
      34 : mist := do_alert('[3][Pfad nicht gefunden !][OKAY]', 1);
      36 : mist := do_alert('[3][Zugriff verweigert !][OKAY]', 1);
      OTHERWISE : mist := do_alert('[3][Unbekannter Fehler][OKAY]', 1);
    END; { case }
  END; { Name wurde ausgewhlt }
END; { procedure neuer_ordner }


{///////////////////////////////////////////////////////////////////////////}
{///   Ermittelt den Namen der Queldatei   /////////////////////////////////}
{///////////////////////////////////////////////////////////////////////////}

PROCEDURE suche_quelldatei;
VAR     vorschlag,
        alt_path        : path_name;
        file_erhalten   : BOOLEAN;
BEGIN
  vorschlag := concat( q_drive, ':\*.', extension);
  alt_path  := in_fil_path;
  file_erhalten := get_in_file( vorschlag, in_fil_path);
  IF length( in_fil_path) > BOX_LEN
  THEN BEGIN
         mist := do_alert('[1][Tut mir leid,|Pfadname zu lang !][OKAY]', 1);
         in_fil_path := alt_path;
         file_erhalten := FALSE;
       END; { Name war zu lang }
  IF file_erhalten
  THEN
  BEGIN
    out_fil_path := in_fil_path;
    out_fil_path[1] := z_drive;
    obj_setstate( dl, ziel_btn, obj_state(dl,ziel_btn) & ~ DISABLED, FALSE);
    obj_setstate( dl, start_btn,obj_state(dl,start_btn)& ~ DISABLED, FALSE);
                        { Selektierung von Ziel und Los gehts erlauben }
    welche_extension( in_fil_path, extension);
    IF in_fil_path[1] IN angemeldet
    THEN q_drive := in_fil_path[1]
    ELSE BEGIN
           nicht_angemeldet_alarm( in_fil_path[1]);
           in_fil_path[1] := q_drive;
         END; { Laufwerk nicht Angemeldet }
  END { Quelle ausgesucht }
  ELSE
  BEGIN
    in_fil_path  := '';
    out_fil_path := '';
    obj_setstate( dl, ziel_btn, (obj_state(dl,ziel_btn) |DISABLED ), FALSE);
    obj_setstate( dl, start_btn,(obj_state(dl,start_btn)|DISABLED ), FALSE);
                        { Selektierung von Ziel und Los gehts unterbinden }
  END; { Auswahl abgebrochen }
END; { procedure suche_quelldatei }


{///////////////////////////////////////////////////////////////////////////}
{///   Ermittelt den Namen der Zieldatei   /////////////////////////////////}
{///////////////////////////////////////////////////////////////////////////}

PROCEDURE suche_zieldatei;
VAR     vorschlag,
        alt_path        : path_name;
        file_erhalten   : BOOLEAN;
BEGIN
  vorschlag := concat( out_fil_path[1], ':\*.', extension);
  alt_path  := out_fil_path;
  file_erhalten := get_in_file( vorschlag, out_fil_path);
  IF length( out_fil_path) > BOX_LEN
  THEN BEGIN
         mist := do_alert('[1][Tut mir leid,|Pfadname zu lang !][OKAY]', 1);
         out_fil_path := alt_path;
         file_erhalten := FALSE;
       END; { Name war zu lang }
  IF file_erhalten
  THEN BEGIN
         IF out_fil_path[1] IN angemeldet
         THEN z_drive := out_fil_path[1]
         ELSE BEGIN
                nicht_angemeldet_alarm( out_fil_path[1]);
                out_fil_path[1] := z_drive;
              END; { Laufwerk nicht Angemeldet }
       END; { File wurde geliefert }
END; { procedure suche_zieldatei }


{///////////////////////////////////////////////////////////////////////////}
{///   Malt das Hintergrundfenster vollstndig aus   ///////////////////////}
{///////////////////////////////////////////////////////////////////////////}

PROCEDURE redraw_hintergrund;
BEGIN
  hide_mouse;
  set_clip( fenst_x, fenst_y, fenst_w, fenst_h);
  paint_color( BLACK);
  paint_style( MUSTER);
  paint_rect( fenst_x, fenst_y, fenst_w, fenst_h);
  show_mouse;
END; { procedure redraw_hintergrund }


{///////////////////////////////////////////////////////////////////////////}
{///   Reagiert auf Aktionen im Dialogfeld   ///////////////////////////////}
{///////////////////////////////////////////////////////////////////////////}

PROCEDURE action;
VAR     i       : INTEGER;
BEGIN                           { Eigenes groes Fenster als Hintergrund }
  fenstername := '';            { sonst Strung durch fremdes WM_REDRAW  }
  fenster := new_window( NONE, fenstername, 0, 0, 0, 0 );
  open_window ( fenster, 0, 0, 0, 0 );
  work_rect( fenster, fenst_x, fenst_y, fenst_w, fenst_h);
  redraw_hintergrund;

  set_mouse( M_ARROW);
  erlaubte_laufwerke;
  erfolg := FALSE;
  wahl := do_dialog( dl, quell_drive);

  LOOP                  { bis Cancel_btn gewhlt oder erfolgreich kopiert }
    kopier_stop := FALSE;

    get_dedit( dl, quell_drive, q_dr_str);      { Laufwerksangaben holen }
    get_dedit( dl, ziel_drive,  z_dr_str);
    IF ( upcase( q_dr_str[1]) <> q_drive) AND ( length(q_dr_str) > 0 )
    THEN IF upcase( q_dr_str[1]) IN angemeldet
         THEN q_drive := upcase( q_dr_str[1])
         ELSE nicht_angemeldet_alarm( upcase( q_dr_str[1]) );
    IF ( upcase( z_dr_str[1]) <> z_drive) AND ( length(z_dr_str) > 0 )
    THEN IF upcase( z_dr_str[1]) IN angemeldet
         THEN z_drive := upcase( z_dr_str[1])
         ELSE nicht_angemeldet_alarm( upcase( z_dr_str[1]) );
    in_fil_path[1]  := q_drive;                 { Laufwerke setzen }
    out_fil_path[1] := z_drive;

    IF ( wahl = start_btn ) AND NOT kopier_stop
    THEN BEGIN
           IF in_fil_path = out_fil_path
           THEN BEGIN           { Kein Backup, da Quelle und Ziel identisch }
                  t := concat( '[3][Quell- und Zieldatei|sind identisch]',
                                  '[ABBRUCH]');
                  mist := do_alert( t, 1);
                END { Backup abgelehnt }
           ELSE BEGIN
                  set_mouse( M_BEE);
                  erfolg := backup( in_fil_path, out_fil_path); { kopieren }
                  set_mouse( M_ARROW);
                END;
         END; { Start_btn gewhlt }

    IF wahl IN [ quell_btn, ziel_btn, ordner_btn]
    THEN redraw_hintergrund;    { Fenster ausmalen fr File-Selector-Box }

    IF wahl = quell_btn  THEN suche_quelldatei;

    IF wahl = ziel_btn   THEN suche_zieldatei;

    IF wahl = ordner_btn THEN neuer_ordner;

    IF wahl IN [ quell_btn, ziel_btn, ordner_btn]
    THEN redraw_hintergrund;    { Fenster wieder ausmalen fr Dialog }

    IF wahl = cancel_btn
    THEN BEGIN END
    ELSE
    BEGIN                                       { Laufwerke neu setzen }
      set_dedit ( dl, quell_drive, '_', 'a', q_drive,SYSTEM_FONT, TE_CENTER);
      set_dedit ( dl,  ziel_drive, '_', 'a', z_drive,SYSTEM_FONT, TE_CENTER);

      IF length( in_fil_path)  > 0      { neue Info - Texte festlegen }
      THEN set_dtext( dl, quell_name, in_fil_path,  SYSTEM_FONT, TE_LEFT)
      ELSE set_dtext( dl, quell_name, frag_leer,    SYSTEM_FONT, TE_LEFT);

      IF length( out_fil_path) > 0
      THEN set_dtext( dl, ziel_name, out_fil_path, SYSTEM_FONT, TE_LEFT)
      ELSE set_dtext( dl, ziel_name, frag_leer,    SYSTEM_FONT, TE_LEFT);
    END; { Cancel_btn wurde nicht gewhlt }
                                        { SELECTED - Status zurcknehmen }
    obj_setstate( dl, wahl, obj_state( dl, wahl) & ~ SELECTED , FALSE);
  EXIT IF ( wahl = cancel_btn ) OR erfolg;
    wahl := do_dialog( dl, quell_drive);
  END; { loop-Schleife }

  end_dialog( dl);
  close_window  ( fenster );    { Hintergrundfenster wieder entfernen }
  delete_window ( fenster );
END; { procedure action }                       { Zurck in event_loop }


{///////////////////////////////////////////////////////////////////////////}
{///   Schaut immer nur, ob das Programm endlich gebraucht wird   //////////}
{///////////////////////////////////////////////////////////////////////////}

PROCEDURE event_loop;
VAR     event   : INTEGER;
        msg     : message_buffer;
BEGIN
  REPEAT
    event := get_event( E_MESSAGE, 0, 0, 0, 0,
                        FALSE, 0, 0, 0, 0, FALSE, 0, 0, 0, 0,
                        msg, mist, mist, mist, mist, mist, mist);
    CASE msg[0] OF AC_OPEN  : action;
                   AC_CLOSE : BEGIN END;
    END; { case }
  UNTIL TRUE = FALSE;           { Wartet bis zum Stromausfall auf Aufruf }
END; { procedure event_loop }

{///////////////////////////////////////////////////////////////////////////}

BEGIN { Hauptprogramm }
  ap_id := init_gem;
  IF ap_id >= 0
  THEN
  BEGIN
    acc_name := '  RAM - Backup';
    menu_id := menu_register( ap_id, acc_name);
    erlaubte_laufwerke;
    initialisiere;
    baue_dialog;
    center_dialog( dl);
    event_loop;
  END; { init_gem erfolgreich }

END.

